JUCE: InputStream Class Reference

JUCE

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
InputStream Class Referenceabstract
juce_core » streams

The base class for streams that read data. More...

`#include <juce_InputStream.h>`

Inheritance diagram for InputStream:

## Public Member Functions
virtual | ~InputStream ()=default
| Destructor.
virtual int64 | getTotalLength ()=0
| Returns the total number of bytes available for reading in this stream.
int64 | getNumBytesRemaining ()
| Returns the number of bytes available for reading, or a negative value if the remaining length is not known.
virtual bool | isExhausted ()=0
| Returns true if the stream has no more data to read.
virtual int | read (void *destBuffer, int maxBytesToRead)=0
| Reads some data from the stream into a memory buffer.
ssize_t | read (void *destBuffer, size_t maxBytesToRead)
virtual char | readByte ()
| Reads a byte from the stream.
virtual bool | readBool ()
| Reads a boolean from the stream.
virtual short | readShort ()
| Reads two bytes from the stream as a little-endian 16-bit value.
virtual short | readShortBigEndian ()
| Reads two bytes from the stream as a little-endian 16-bit value.
virtual int | readInt ()
| Reads four bytes from the stream as a little-endian 32-bit value.
virtual int | readIntBigEndian ()
| Reads four bytes from the stream as a big-endian 32-bit value.
virtual int64 | readInt64 ()
| Reads eight bytes from the stream as a little-endian 64-bit value.
virtual int64 | readInt64BigEndian ()
| Reads eight bytes from the stream as a big-endian 64-bit value.
virtual float | readFloat ()
| Reads four bytes as a 32-bit floating point value.
virtual float | readFloatBigEndian ()
| Reads four bytes as a 32-bit floating point value.
virtual double | readDouble ()
| Reads eight bytes as a 64-bit floating point value.
virtual double | readDoubleBigEndian ()
| Reads eight bytes as a 64-bit floating point value.
virtual int | readCompressedInt ()
| Reads an encoded 32-bit number from the stream using a space-saving compressed format.
virtual String | readNextLine ()
| Reads a UTF-8 string from the stream, up to the next linefeed or carriage return.
virtual String | readString ()
| Reads a zero-terminated UTF-8 string from the stream.
virtual String | readEntireStreamAsString ()
| Tries to read the whole stream and turn it into a string.
virtual size_t | readIntoMemoryBlock (MemoryBlock &destBlock, ssize_t maxNumBytesToRead=-1)
| Reads from the stream and appends the data to a MemoryBlock.
virtual int64 | getPosition ()=0
| Returns the offset of the next byte that will be read from the stream.
virtual bool | setPosition (int64 newPosition)=0
| Tries to move the current read position of the stream.
virtual void | skipNextBytes (int64 numBytesToSkip)
| Reads and discards a number of bytes from the stream.

## Protected Member Functions
| InputStream ()=default

## Detailed Description

The base class for streams that read data.

Input and output streams are used throughout the library - subclasses can override some or all of the virtual functions to implement their behaviour.

See also
  OutputStream, MemoryInputStream, BufferedInputStream, FileInputStream

## Constructor & Destructor Documentation

## ◆ ~InputStream()

virtual InputStream::~InputStream | ( |  | ) |
| virtualdefault

Destructor.

## ◆ InputStream()

InputStream::InputStream | ( |  | ) |
| protecteddefault

## Member Function Documentation

## ◆ getTotalLength()

virtual int64 InputStream::getTotalLength | ( |  | ) |
| pure virtual

Returns the total number of bytes available for reading in this stream.

Note that this is the number of bytes available from the start of the stream, not from the current position.

If the size of the stream isn't actually known, this will return -1.

See also
  getNumBytesRemaining

Implemented in ARAInputStream, FileInputStream, WebInputStream, BufferedInputStream, MemoryInputStream, SubregionStream, and GZIPDecompressorInputStream.

## ◆ getNumBytesRemaining()

int64 InputStream::getNumBytesRemaining | ( |  | ) |

Returns the number of bytes available for reading, or a negative value if the remaining length is not known.

See also
  getTotalLength

## ◆ isExhausted()

virtual bool InputStream::isExhausted | ( |  | ) |
| pure virtual

Returns true if the stream has no more data to read.

Implemented in ARAInputStream, FileInputStream, WebInputStream, BufferedInputStream, MemoryInputStream, SubregionStream, and GZIPDecompressorInputStream.

## ◆ read() [1/2]

virtual int InputStream::read | ( | void * | destBuffer,
|  | int | maxBytesToRead
| ) |  |
| pure virtual

Reads some data from the stream into a memory buffer.

This is the only read method that subclasses actually need to implement, as the InputStream base class implements the other read methods in terms of this one (although it's often more efficient for subclasses to implement them directly).

Parameters

  destBuffer | the destination buffer for the data. This must not be null.
  maxBytesToRead | the maximum number of bytes to read - make sure the memory block passed in is big enough to contain this many bytes. This value must not be negative.

Returns
  the actual number of bytes that were read, which may be less than maxBytesToRead if the stream is exhausted before it gets that far

Implemented in ARAInputStream, FileInputStream, WebInputStream, BufferedInputStream, MemoryInputStream, SubregionStream, and GZIPDecompressorInputStream.

## ◆ read() [2/2]

ssize_t InputStream::read | ( | void * | destBuffer,
|  | size_t | maxBytesToRead
| ) |  |

## ◆ readByte()

virtual char InputStream::readByte | ( |  | ) |
| virtual

Reads a byte from the stream.

If the stream is exhausted, this will return zero.

See also
  OutputStream::writeByte

## ◆ readBool()

virtual bool InputStream::readBool | ( |  | ) |
| virtual

Reads a boolean from the stream.

The bool is encoded as a single byte - non-zero for true, 0 for false. If the stream is exhausted, this will return false.

See also
  OutputStream::writeBool

## ◆ readShort()

virtual short InputStream::readShort | ( |  | ) |
| virtual

Reads two bytes from the stream as a little-endian 16-bit value.

If the next two bytes read are byte1 and byte2, this returns (byte1 | (byte2 << 8)). If the stream is exhausted partway through reading the bytes, this will return zero.

See also
  OutputStream::writeShort, readShortBigEndian

## ◆ readShortBigEndian()

virtual short InputStream::readShortBigEndian | ( |  | ) |
| virtual

Reads two bytes from the stream as a little-endian 16-bit value.

If the next two bytes read are byte1 and byte2, this returns (byte2 | (byte1 << 8)). If the stream is exhausted partway through reading the bytes, this will return zero.

See also
  OutputStream::writeShortBigEndian, readShort

## ◆ readInt()

virtual int InputStream::readInt | ( |  | ) |
| virtual

Reads four bytes from the stream as a little-endian 32-bit value.

If the next four bytes are byte1 to byte4, this returns (byte1 | (byte2 << 8) | (byte3 << 16) | (byte4 << 24)).

If the stream is exhausted partway through reading the bytes, this will return zero.

See also
  OutputStream::writeInt, readIntBigEndian

## ◆ readIntBigEndian()

virtual int InputStream::readIntBigEndian | ( |  | ) |
| virtual

Reads four bytes from the stream as a big-endian 32-bit value.

If the next four bytes are byte1 to byte4, this returns (byte4 | (byte3 << 8) | (byte2 << 16) | (byte1 << 24)).

If the stream is exhausted partway through reading the bytes, this will return zero.

See also
  OutputStream::writeIntBigEndian, readInt

## ◆ readInt64()

virtual int64 InputStream::readInt64 | ( |  | ) |
| virtual

Reads eight bytes from the stream as a little-endian 64-bit value.

If the next eight bytes are byte1 to byte8, this returns (byte1 | (byte2 << 8) | (byte3 << 16) | (byte4 << 24) | (byte5 << 32) | (byte6 << 40) | (byte7 << 48) | (byte8 << 56)).

If the stream is exhausted partway through reading the bytes, this will return zero.

See also
  OutputStream::writeInt64, readInt64BigEndian

## ◆ readInt64BigEndian()

virtual int64 InputStream::readInt64BigEndian | ( |  | ) |
| virtual

Reads eight bytes from the stream as a big-endian 64-bit value.

If the next eight bytes are byte1 to byte8, this returns (byte8 | (byte7 << 8) | (byte6 << 16) | (byte5 << 24) | (byte4 << 32) | (byte3 << 40) | (byte2 << 48) | (byte1 << 56)).

If the stream is exhausted partway through reading the bytes, this will return zero.

See also
  OutputStream::writeInt64BigEndian, readInt64

## ◆ readFloat()

virtual float InputStream::readFloat | ( |  | ) |
| virtual

Reads four bytes as a 32-bit floating point value.

The raw 32-bit encoding of the float is read from the stream as a little-endian int. If the stream is exhausted partway through reading the bytes, this will return zero.

See also
  OutputStream::writeFloat, readDouble

## ◆ readFloatBigEndian()

virtual float InputStream::readFloatBigEndian | ( |  | ) |
| virtual

Reads four bytes as a 32-bit floating point value.

The raw 32-bit encoding of the float is read from the stream as a big-endian int. If the stream is exhausted partway through reading the bytes, this will return zero.

See also
  OutputStream::writeFloatBigEndian, readDoubleBigEndian

## ◆ readDouble()

virtual double InputStream::readDouble | ( |  | ) |
| virtual

Reads eight bytes as a 64-bit floating point value.

The raw 64-bit encoding of the double is read from the stream as a little-endian int64. If the stream is exhausted partway through reading the bytes, this will return zero.

See also
  OutputStream::writeDouble, readFloat

## ◆ readDoubleBigEndian()

virtual double InputStream::readDoubleBigEndian | ( |  | ) |
| virtual

Reads eight bytes as a 64-bit floating point value.

The raw 64-bit encoding of the double is read from the stream as a big-endian int64. If the stream is exhausted partway through reading the bytes, this will return zero.

See also
  OutputStream::writeDoubleBigEndian, readFloatBigEndian

## ◆ readCompressedInt()

virtual int InputStream::readCompressedInt | ( |  | ) |
| virtual

Reads an encoded 32-bit number from the stream using a space-saving compressed format.

For small values, this is more space-efficient than using readInt() and OutputStream::writeInt() The format used is: number of significant bytes + up to 4 bytes in little-endian order.

See also
  OutputStream::writeCompressedInt()

## ◆ readNextLine()

virtual String InputStream::readNextLine | ( |  | ) |
| virtual

Reads a UTF-8 string from the stream, up to the next linefeed or carriage return.

This will read up to the next "\n" or "\r\n" or end-of-stream.

After this call, the stream's position will be left pointing to the next character following the line-feed, but the linefeeds aren't included in the string that is returned.

## ◆ readString()

virtual String InputStream::readString | ( |  | ) |
| virtual

Reads a zero-terminated UTF-8 string from the stream.

This will read characters from the stream until it hits a null character or end-of-stream.

See also
  OutputStream::writeString, readEntireStreamAsString

Reimplemented in BufferedInputStream.

## ◆ readEntireStreamAsString()

virtual String InputStream::readEntireStreamAsString | ( |  | ) |
| virtual

Tries to read the whole stream and turn it into a string.

This will read from the stream's current position until the end-of-stream. It can read from UTF-8 data, or UTF-16 if it detects suitable header-bytes.

## ◆ readIntoMemoryBlock()

virtual size_t InputStream::readIntoMemoryBlock | ( | MemoryBlock & | destBlock,
|  | ssize_t | maxNumBytesToRead = `-1`
| ) |  |
| virtual

Reads from the stream and appends the data to a MemoryBlock.

Parameters

  destBlock | the block to append the data onto
  maxNumBytesToRead | if this is a positive value, it sets a limit to the number of bytes that will be read - if it's negative, data will be read until the stream is exhausted.

Returns
  the number of bytes that were added to the memory block

## ◆ getPosition()

virtual int64 InputStream::getPosition | ( |  | ) |
| pure virtual

Returns the offset of the next byte that will be read from the stream.

See also
  setPosition

Implemented in ARAInputStream, FileInputStream, WebInputStream, BufferedInputStream, MemoryInputStream, SubregionStream, and GZIPDecompressorInputStream.

## ◆ setPosition()

virtual bool InputStream::setPosition | ( | int64 | newPosition | ) |
| pure virtual

Tries to move the current read position of the stream.

The position is an absolute number of bytes from the stream's start.

Some streams might not be able to do this, in which case they should do nothing and return false. Others might be able to manage it by resetting themselves and skipping to the correct position, although this is obviously a bit slow.

Returns
  true if the stream manages to reposition itself correctly

See also
  getPosition

Implemented in BufferedInputStream, SubregionStream, GZIPDecompressorInputStream, WebInputStream, ARAInputStream, FileInputStream, and MemoryInputStream.

## ◆ skipNextBytes()

virtual void InputStream::skipNextBytes | ( | int64 | numBytesToSkip | ) |
| virtual

Reads and discards a number of bytes from the stream.

Some input streams might implement this more efficiently, but the base class will just keep reading data until the requisite number of bytes have been done. For large skips it may be quicker to call setPosition() with the required position.

Reimplemented in MemoryInputStream.

The documentation for this class was generated from the following file:

- juce_InputStream.h